diff a/src/java.base/share/classes/jdk/internal/classfile/impl/BoundAttribute.java b/src/java.base/share/classes/jdk/internal/classfile/impl/BoundAttribute.java
--- a/src/java.base/share/classes/jdk/internal/classfile/impl/BoundAttribute.java
+++ b/src/java.base/share/classes/jdk/internal/classfile/impl/BoundAttribute.java
@@ -933,10 +933,27 @@
             }
             return permittedSubclasses;
         }
     }
 
+    public static final class BoundPreloadAttribute extends BoundAttribute<PreloadAttribute>
+            implements PreloadAttribute {
+        private List<ClassEntry> preloads = null;
+
+        public BoundPreloadAttribute(ClassReader cf, AttributeMapper<PreloadAttribute> mapper, int pos) {
+            super(cf, mapper, pos);
+        }
+
+        @Override
+        public List<ClassEntry> preloads() {
+            if (preloads == null) {
+                preloads = readEntryList(payloadStart);
+            }
+            return preloads;
+        }
+    }
+
     public static abstract sealed class BoundCodeAttribute
             extends BoundAttribute<CodeAttribute>
             implements CodeAttribute
             permits CodeImpl {
         protected final int codeStart;
